﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Telerik.WinControls.RadControlSpy;
using Telerik.WinControls.UI;

namespace _880783_RadAutoCompleteBox
{
    public partial class Form1 : Form
    {
        string[] coffeeDrinks =
        {
            "Americano",
            "Cafe Crema",
            "Caffe Latte",
            "Caffe macchiato",
            "Coffee milk",
            "Cafe mocha",
            "Irish coffee",
            "Espresso",
            "espresso long",
            "Cuban espresso",
            "Frappuccino",
            "Greek frappe coffee",
            "Indian filter coffee",
            "Iced Coffee ",
            "Cafe mélange"
        };

        public Form1()
        {
            InitializeComponent();
            new RadControlSpyForm().Show();
            DataTable tableDrinks = new DataTable();
            tableDrinks.Columns.Add("ProductID", typeof(int));
            tableDrinks.Columns.Add("Description", typeof(string));
            tableDrinks.Columns.Add("State", typeof(bool));

            for (int i = 0; i < coffeeDrinks.Length; i++)
            {
                if (i % 2 == 0)
                {
                    tableDrinks.Rows.Add(i, coffeeDrinks[i], true);
                }
                else
                {
                    tableDrinks.Rows.Add(i, coffeeDrinks[i], false);
                }
            }

            this.radAutoCompleteBox1.AutoCompleteDisplayMember = "Description";
            this.radAutoCompleteBox1.AutoCompleteValueMember = "ProductID";
            this.radAutoCompleteBox1.AutoCompleteDataSource = tableDrinks;
            this.radAutoCompleteBox1.AutoCompleteMode = AutoCompleteMode.Suggest;

            this.radAutoCompleteBox1.ListElement.VisualItemFormatting += ListElement_VisualItemFormatting;
            this.radAutoCompleteBox1.TextBlockFormatting += radAutoCompleteBox1_TextBlockFormatting;
            this.radAutoCompleteBox1.CreateTextBlock += radAutoCompleteBox1_CreateTextBlock;        
        }

        void radAutoCompleteBox1_CreateTextBlock(object sender, CreateTextBlockEventArgs e)
        {
            if (e.TextBlock is TokenizedTextBlockElement)
            {
                e.TextBlock = new MyTokenizedTextBlockElement();
            }
        }

        void radAutoCompleteBox1_TextBlockFormatting(object sender, Telerik.WinControls.UI.TextBlockFormattingEventArgs e)
        {
            TokenizedTextBlockElement token = e.TextBlock as TokenizedTextBlockElement;
            if (token != null && token.Item.Value != null)
            {
                token.DrawText = false;
                token.Text = string.Format("({0})", token.Item.Value);
            }
        }
      
        void ListElement_VisualItemFormatting(object sender, Telerik.WinControls.UI.VisualItemFormattingEventArgs args)
        {
            var dataItem = args.VisualItem.Data;
            args.VisualItem.Text = string.Format("{1} ({0})", dataItem.Text, dataItem.Value); 
        }
    }

    class MyTokenizedTextBlockElement : TokenizedTextBlockElement
    {
        protected override Type ThemeEffectiveType
        {
            get
            {
                return typeof(TokenizedTextBlockElement);
            }
        }

        public override string Text
        {
            get
            {
                return this.ContentElement.Text;
            }
            set
            {
                base.Text = value;
                this.ContentElement.Text = value.ToString();
            }
        }
    }
}
